Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpict.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxpict.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpict.c
@@ -698,9 +1335,10 @@ static Picture dmxDoCreatePicture(Pictur
     ScreenPtr                 pScreen   = pDraw->pScreen;
     DMXScreenInfo            *dmxScreen = &dmxScreens[pScreen->myNum];
     XRenderPictFormat        *pFormat;
-    Drawable                  draw;
+    Drawable                 draw;
+    Picture pict = 0;
 
-    if (pPicture->pDrawable->type == DRAWABLE_WINDOW) {
+    if (pDraw->type == DRAWABLE_WINDOW) {
 	dmxWinPrivPtr  pWinPriv = DMX_GET_WINDOW_PRIV((WindowPtr)(pDraw));
 
 	if (!(draw = pWinPriv->window)) {
@@ -729,7 +1367,11 @@ static Picture dmxDoCreatePicture(Pictur
 
     pFormat = dmxFindFormat(dmxScreen, pPicture->pFormat);
 
-    return XRenderCreatePicture(dmxScreen->beDisplay, draw, pFormat, 0, 0);
+    XLIB_PROLOGUE (dmxScreen);
+    pict = XRenderCreatePicture(dmxScreen->beDisplay, draw, pFormat, 0, 0);
+    XLIB_EPILOGUE (dmxScreen);
+
+    return pict;
 }
 
 /** Create a list of pictures.  This function is called by
@@ -753,15 +1395,47 @@ void dmxCreatePictureList(WindowPtr pWin
 }
 
 /** Create \a pPicture on the backend. */
-int dmxBECreatePicture(PicturePtr pPicture)
+int dmxBECreatePicture(int idx, PicturePtr pPicture)
 {
     dmxPictPrivPtr    pPictPriv = DMX_GET_PICT_PRIV(pPicture);
 
-    /* Create picutre on BE */
-    pPictPriv->pict = dmxDoCreatePicture(pPicture);
+    /* Create picture on BE */
+    if (pPicture->pDrawable)
+    {
+	pPictPriv->pict = dmxDoCreatePicture(pPicture);
 
-    /* Flush changes to the backend server */
-    dmxValidatePicture(pPicture, (1 << (CPLastBit+1)) - 1);
+	/* Flush changes to the backend server */
+	dmxValidatePicture(pPicture, (1 << (CPLastBit+1)) - 1);
+    }
+    else
+    {
+	pPictPriv->sourcePict[idx] = dmxDoCreateSourcePicture(idx, pPicture);
+	if (pPictPriv->sourcePict[idx])
+	{
+	    DMXScreenInfo            *dmxScreen = &dmxScreens[idx];
+	    XRenderPictureAttributes attribs;
+	    XTransform		     xform;
+	    int                      i, j;
+
+	    attribs.repeat = pPicture->repeatType;
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    XRenderChangePicture(dmxScreen->beDisplay,
+				 pPictPriv->sourcePict[idx],
+				 CPRepeat, &attribs);
+	    XLIB_EPILOGUE (dmxScreen);
+
+	    for (i = 0; i < 3; i++)
+		for (j = 0; j < 3; j++)
+		    xform.matrix[i][j] = pPicture->transform->matrix[i][j];
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    XRenderSetPictureTransform(dmxScreen->beDisplay,
+				       pPictPriv->sourcePict[idx],
+				       &xform);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
+    }
 
     return Success;
 }
@@ -784,7 +1458,8 @@ int dmxCreatePicture(PicturePtr pPicture
 #endif
 
     /* Create picture on back-end server */
-    pPictPriv->pict      = dmxDoCreatePicture(pPicture);
+    pPictPriv->pict = dmxDoCreatePicture(pPicture);
+    pPictPriv->sourcePict = NULL;
     pPictPriv->savedMask = 0;
 
     DMX_WRAP(CreatePicture, dmxCreatePicture, dmxScreen, ps);
@@ -793,17 +1468,27 @@ int dmxCreatePicture(PicturePtr pPicture
 }
 
 /** Destroy \a pPicture on the back-end server. */
-Bool dmxBEFreePicture(PicturePtr pPicture)
+Bool dmxBEFreePicture(ScreenPtr pScreen, PicturePtr pPicture)
 {
-    ScreenPtr      pScreen   = pPicture->pDrawable->pScreen;
     DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
     dmxPictPrivPtr pPictPriv = DMX_GET_PICT_PRIV(pPicture);
 
     if (pPictPriv->pict) {
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderFreePicture(dmxScreen->beDisplay, pPictPriv->pict);
+	XLIB_EPILOGUE (dmxScreen);
 	pPictPriv->pict = (Picture)0;
 	return TRUE;
     }
+    if (pPictPriv->sourcePict) {
+	if (pPictPriv->sourcePict[pScreen->myNum]) {
+	    XLIB_PROLOGUE (dmxScreen);
+	    XRenderFreePicture(dmxScreen->beDisplay,
+			       pPictPriv->sourcePict[pScreen->myNum]);
+	    XLIB_EPILOGUE (dmxScreen);
+	    pPictPriv->sourcePict[pScreen->myNum] = (Picture) 0;
+	}
+    }
 
     return FALSE;
 }
@@ -817,7 +1502,7 @@ Bool dmxDestroyPictureList(WindowPtr pWi
     Bool        ret      = FALSE;
 
     while (pPicture) {
-	ret |= dmxBEFreePicture(pPicture);
+	ret |= dmxBEFreePicture(pWindow->drawable.pScreen, pPicture);
 	pPicture = pPicture->pNext;
     }
 
@@ -836,7 +1521,7 @@ void dmxDestroyPicture(PicturePtr pPictu
     DMX_UNWRAP(DestroyPicture, dmxScreen, ps);
 
     /* Destroy picture on back-end server */
-    if (dmxBEFreePicture(pPicture))
+    if (dmxBEFreePicture(pScreen, pPicture))
 	dmxSync(dmxScreen, FALSE);
 
 #if 1
@@ -868,8 +1553,10 @@ int dmxChangePictureClip(PicturePtr pPic
 	 */
 	if (clipType == CT_NONE) {
 	    /* Disable clipping, show all */
+	    XLIB_PROLOGUE (dmxScreen);
 	    XFixesSetPictureClipRegion(dmxScreen->beDisplay,
 				       pPictPriv->pict, 0, 0, None);
+	    XLIB_EPILOGUE (dmxScreen);
 	} else if (pPicture->clientClip) {
 	    RegionPtr   pClip = pPicture->clientClip;
 	    BoxPtr      pBox  = REGION_RECTS(pClip);
@@ -890,16 +1577,20 @@ int dmxChangePictureClip(PicturePtr pPic
 		pRect++;
 	    }
 
+	    XLIB_PROLOGUE (dmxScreen);
 	    XRenderSetPictureClipRectangles(dmxScreen->beDisplay,
 					    pPictPriv->pict,
 					    0, 0,
 					    pRects,
 					    nRects);
+	    XLIB_EPILOGUE (dmxScreen);
 	    xfree(pRects);
 	} else {
+	    XLIB_PROLOGUE (dmxScreen);
 	    XRenderSetPictureClipRectangles(dmxScreen->beDisplay,
 					    pPictPriv->pict,
 					    0, 0, NULL, 0);
+	    XLIB_EPILOGUE (dmxScreen);
 	}
 	dmxSync(dmxScreen, FALSE);
     } else {
@@ -927,9 +1618,11 @@ void dmxDestroyPictureClip(PicturePtr pP
 
     /* Destroy picture clip rects on back-end server */
     if (pPictPriv->pict) {
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderSetPictureClipRectangles(dmxScreen->beDisplay,
 					pPictPriv->pict,
 					0, 0, NULL, 0);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     } else {
 	/* FIXME: Handle destroying clip region when offscreen */
@@ -1017,9 +1710,10 @@ void dmxValidatePicture(PicturePtr pPict
 	if (mask & CPComponentAlpha)
 	    attribs.component_alpha = pPicture->componentAlpha;
 
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderChangePicture(dmxScreen->beDisplay, pPictPriv->pict,
 			     mask, &attribs);
-	dmxSync(dmxScreen, FALSE);
+	XLIB_EPILOGUE (dmxScreen);
     } else {
 	pPictPriv->savedMask |= mask;
     }
@@ -1047,11 +1741,22 @@ void dmxComposite(CARD8 op,
     ScreenPtr         pScreen   = pDst->pDrawable->pScreen;
     DMXScreenInfo    *dmxScreen = &dmxScreens[pScreen->myNum];
     PictureScreenPtr  ps        = GetPictureScreen(pScreen);
-    dmxPictPrivPtr    pSrcPriv  = DMX_GET_PICT_PRIV(pSrc);
-    dmxPictPrivPtr    pMaskPriv = NULL;
     dmxPictPrivPtr    pDstPriv  = DMX_GET_PICT_PRIV(pDst);
+    Picture	      src = None;
+    Picture	      mask = None;
 
-    if (pMask) pMaskPriv = DMX_GET_PICT_PRIV(pMask);
+    if (pSrc->pDrawable)
+	src = (DMX_GET_PICT_PRIV (pSrc))->pict;
+    else
+	src = (DMX_GET_PICT_PRIV (pSrc))->sourcePict[pScreen->myNum];
+
+    if (pMask)
+    {
+	if (pMask->pDrawable)
+	    mask = (DMX_GET_PICT_PRIV (pMask))->pict;
+	else
+	    mask = (DMX_GET_PICT_PRIV (pMask))->sourcePict[pScreen->myNum];
+    }
 
     DMX_UNWRAP(Composite, dmxScreen, ps);
 #if 0
@@ -1062,21 +1767,22 @@ void dmxComposite(CARD8 op,
 #endif
 
     /* Composite on back-end server */
-    if (pSrcPriv->pict && pDstPriv->pict &&
-	((pMaskPriv && pMaskPriv->pict) || !pMaskPriv)) {
+    if (src && pDstPriv->pict)
+    {
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderComposite(dmxScreen->beDisplay,
 			 op,
-			 pSrcPriv->pict,
-			 pMaskPriv ? pMaskPriv->pict : None,
+			 src,
+			 mask,
 			 pDstPriv->pict,
 			 xSrc, ySrc,
 			 xMask, yMask,
 			 xDst, yDst,
 			 width, height);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
-
     DMX_WRAP(Composite, dmxComposite, dmxScreen, ps);
 }
 
@@ -1114,12 +1820,14 @@ void dmxCompositeRects(CARD8 op,
 
     /* CompositeRects on back-end server */
     if (pPictPriv->pict) {
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderFillRectangles(dmxScreen->beDisplay,
 			      op,
 			      pPictPriv->pict,
 			      (XRenderColor *)color,
 			      (XRectangle *)rects,
 			      nRect);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
@@ -1154,8 +1862,8 @@ void dmxTrapezoids(CARD8 op, PicturePtr
     ScreenPtr         pScreen   = pDst->pDrawable->pScreen;
     DMXScreenInfo    *dmxScreen = &dmxScreens[pScreen->myNum];
     PictureScreenPtr  ps        = GetPictureScreen(pScreen);
-    dmxPictPrivPtr    pSrcPriv  = DMX_GET_PICT_PRIV(pSrc);
     dmxPictPrivPtr    pDstPriv  = DMX_GET_PICT_PRIV(pDst);
+    Picture	      src = None;
 
     DMX_UNWRAP(Trapezoids, dmxScreen, ps);
 #if 0
@@ -1163,6 +1871,11 @@ void dmxTrapezoids(CARD8 op, PicturePtr
 	ps->Trapezoids(op, pSrc, pDst, maskFormat, xSrc, ySrc, ntrap, *traps);
 #endif
 
+    if (pSrc->pDrawable)
+	src = (DMX_GET_PICT_PRIV (pSrc))->pict;
+    else
+	src = (DMX_GET_PICT_PRIV (pSrc))->sourcePict[pScreen->myNum];
+
     /* Draw trapezoids on back-end server */
     if (pDstPriv->pict) {
 	XRenderPictFormat *pFormat;
@@ -1172,14 +1885,16 @@ void dmxTrapezoids(CARD8 op, PicturePtr
 	    /* FIXME: Error! */
 	}
 
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderCompositeTrapezoids(dmxScreen->beDisplay,
 				   op,
-				   pSrcPriv->pict,
+				   src,
 				   pDstPriv->pict,
 				   pFormat,
 				   xSrc, ySrc,
 				   (XTrapezoid *)traps,
 				   ntrap);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
@@ -1197,8 +1912,8 @@ void dmxTriangles(CARD8 op, PicturePtr p
     ScreenPtr         pScreen   = pDst->pDrawable->pScreen;
     DMXScreenInfo    *dmxScreen = &dmxScreens[pScreen->myNum];
     PictureScreenPtr  ps        = GetPictureScreen(pScreen);
-    dmxPictPrivPtr    pSrcPriv  = DMX_GET_PICT_PRIV(pSrc);
     dmxPictPrivPtr    pDstPriv  = DMX_GET_PICT_PRIV(pDst);
+    Picture	      src = None;
 
     DMX_UNWRAP(Triangles, dmxScreen, ps);
 #if 0
@@ -1206,6 +1921,11 @@ void dmxTriangles(CARD8 op, PicturePtr p
 	ps->Triangles(op, pSrc, pDst, maskFormat, xSrc, ySrc, ntri, *tris);
 #endif
 
+    if (pSrc->pDrawable)
+	src = (DMX_GET_PICT_PRIV (pSrc))->pict;
+    else
+	src = (DMX_GET_PICT_PRIV (pSrc))->sourcePict[pScreen->myNum];
+
     /* Draw trapezoids on back-end server */
     if (pDstPriv->pict) {
 	XRenderPictFormat *pFormat;
@@ -1215,14 +1935,16 @@ void dmxTriangles(CARD8 op, PicturePtr p
 	    /* FIXME: Error! */
 	}
 
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderCompositeTriangles(dmxScreen->beDisplay,
 				  op,
-				  pSrcPriv->pict,
+				  src,
 				  pDstPriv->pict,
 				  pFormat,
 				  xSrc, ySrc,
 				  (XTriangle *)tris,
 				  ntri);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
@@ -1240,8 +1962,8 @@ void dmxTriStrip(CARD8 op, PicturePtr pS
     ScreenPtr         pScreen   = pDst->pDrawable->pScreen;
     DMXScreenInfo    *dmxScreen = &dmxScreens[pScreen->myNum];
     PictureScreenPtr  ps        = GetPictureScreen(pScreen);
-    dmxPictPrivPtr    pSrcPriv  = DMX_GET_PICT_PRIV(pSrc);
     dmxPictPrivPtr    pDstPriv  = DMX_GET_PICT_PRIV(pDst);
+    Picture	      src = None;
 
     DMX_UNWRAP(TriStrip, dmxScreen, ps);
 #if 0
@@ -1249,6 +1971,11 @@ void dmxTriStrip(CARD8 op, PicturePtr pS
 	ps->TriStrip(op, pSrc, pDst, maskFormat, xSrc, ySrc, npoint, *points);
 #endif
 
+    if (pSrc->pDrawable)
+	src = (DMX_GET_PICT_PRIV (pSrc))->pict;
+    else
+	src = (DMX_GET_PICT_PRIV (pSrc))->sourcePict[pScreen->myNum];
+
     /* Draw trapezoids on back-end server */
     if (pDstPriv->pict) {
 	XRenderPictFormat *pFormat;
@@ -1258,14 +1985,16 @@ void dmxTriStrip(CARD8 op, PicturePtr pS
 	    /* FIXME: Error! */
 	}
 
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderCompositeTriStrip(dmxScreen->beDisplay,
 				 op,
-				 pSrcPriv->pict,
+				 src,
 				 pDstPriv->pict,
 				 pFormat,
 				 xSrc, ySrc,
 				 (XPointFixed *)points,
 				 npoint);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
@@ -1282,8 +2011,8 @@ void dmxTriFan(CARD8 op, PicturePtr pSrc
     ScreenPtr         pScreen   = pDst->pDrawable->pScreen;
     DMXScreenInfo    *dmxScreen = &dmxScreens[pScreen->myNum];
     PictureScreenPtr  ps        = GetPictureScreen(pScreen);
-    dmxPictPrivPtr    pSrcPriv  = DMX_GET_PICT_PRIV(pSrc);
     dmxPictPrivPtr    pDstPriv  = DMX_GET_PICT_PRIV(pDst);
+    Picture	      src = None;
 
     DMX_UNWRAP(TriFan, dmxScreen, ps);
 #if 0
@@ -1291,6 +2020,11 @@ void dmxTriFan(CARD8 op, PicturePtr pSrc
 	ps->TriFan(op, pSrc, pDst, maskFormat, xSrc, ySrc, npoint, *points);
 #endif
 
+    if (pSrc->pDrawable)
+	src = (DMX_GET_PICT_PRIV (pSrc))->pict;
+    else
+	src = (DMX_GET_PICT_PRIV (pSrc))->sourcePict[pScreen->myNum];
+
     /* Draw trapezoids on back-end server */
     if (pDstPriv->pict) {
 	XRenderPictFormat *pFormat;
@@ -1300,14 +2034,16 @@ void dmxTriFan(CARD8 op, PicturePtr pSrc
 	    /* FIXME: Error! */
 	}
 
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderCompositeTriFan(dmxScreen->beDisplay,
 			       op,
-			       pSrcPriv->pict,
+			       src,
 			       pDstPriv->pict,
 			       pFormat,
 			       xSrc, ySrc,
 			       (XPointFixed *)points,
 			       npoint);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpict.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxpict.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpict.h
@@ -46,6 +46,7 @@ typedef struct _dmxPictPriv {
     Picture  pict;		/**< Picture ID from back-end server */
     Mask     savedMask;         /**< Mask of picture attributes saved for
 				 *   lazy window creation. */
+    Picture  *sourcePict;
 } dmxPictPrivRec, *dmxPictPrivPtr;
 
 
@@ -113,20 +114,17 @@ extern void dmxTriFan(CARD8 op,
 
 extern int dmxBECreateGlyphSet(int idx, GlyphSetPtr glyphSet);
 extern Bool dmxBEFreeGlyphSet(ScreenPtr pScreen, GlyphSetPtr glyphSet);
-extern int dmxBECreatePicture(PicturePtr pPicture);
-extern Bool dmxBEFreePicture(PicturePtr pPicture);
+extern int dmxBECreatePicture(int idx, PicturePtr pPicture);
+extern Bool dmxBEFreePicture(ScreenPtr pScreen, PicturePtr pPicture);
 
 extern DevPrivateKey dmxPictPrivateKey;	/**< Index for picture private data */
 extern DevPrivateKey dmxGlyphSetPrivateKey; /**< Index for glyphset private data */
-
+extern DevPrivateKey dmxGlyphPrivateKey; /**< Index for glyph private data */
 
 /** Get the picture private data given a picture pointer */
 #define DMX_GET_PICT_PRIV(_pPict)					\
     (dmxPictPrivPtr)dixLookupPrivate(&(_pPict)->devPrivates, dmxPictPrivateKey)
 
-/** Set the glyphset private data given a glyphset pointer */
-#define DMX_SET_GLYPH_PRIV(_pGlyph, _pPriv)				\
-    GlyphSetSetPrivate((_pGlyph), dmxGlyphSetPrivateKey, (_pPriv))
 /** Get the glyphset private data given a glyphset pointer */
 #define DMX_GET_GLYPH_PRIV(_pGlyph)					\
     (dmxGlyphPrivPtr)GlyphSetGetPrivate((_pGlyph), dmxGlyphSetPrivateKey)
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpixmap.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxpixmap.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpixmap.c
@@ -70,11 +70,13 @@ void dmxBECreatePixmap(PixmapPtr pPixmap
 	return;
 
     if (pPixmap->drawable.width && pPixmap->drawable.height) {
+	XLIB_PROLOGUE (dmxScreen);
 	pPixPriv->pixmap = XCreatePixmap(dmxScreen->beDisplay,
 					 dmxScreen->scrnWin,
 					 pPixmap->drawable.width,
 					 pPixmap->drawable.height,
 					 pPixmap->drawable.depth);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 }
@@ -122,9 +124,13 @@ PixmapPtr dmxCreatePixmap(ScreenPtr pScr
     pPixPriv->pixmap = (Pixmap)0;
     pPixPriv->detachedImage = NULL;
 
-    /* Create the pixmap on the back-end server */
-    if (dmxScreen->beDisplay) {
-	dmxBECreatePixmap(pPixmap);
+    if (usage_hint != CREATE_PIXMAP_USAGE_GLYPH_PICTURE &&
+	usage_hint != CREATE_PIXMAP_USAGE_BACKING_PIXMAP)
+    {
+	/* Create the pixmap on the back-end server */
+	if (dmxScreen->beDisplay) {
+	    dmxBECreatePixmap(pPixmap);
+	}
     }
 
 #if 0
@@ -142,7 +148,9 @@ Bool dmxBEFreePixmap(PixmapPtr pPixmap)
     dmxPixPrivPtr  pPixPriv = DMX_GET_PIXMAP_PRIV(pPixmap);
 
     if (pPixPriv->pixmap) {
+	XLIB_PROLOGUE (dmxScreen);
 	XFreePixmap(dmxScreen->beDisplay, pPixPriv->pixmap);
+	XLIB_EPILOGUE (dmxScreen);
 	pPixPriv->pixmap = (Pixmap)0;
 	return TRUE;
     }
@@ -150,6 +158,15 @@ Bool dmxBEFreePixmap(PixmapPtr pPixmap)
     return FALSE;
 }
 
+static Bool FoundPix = False;
+
+static void findPixmap (pointer value, XID id, RESTYPE type, pointer p)
+{
+    if ((type & TypeMask) == (RT_PIXMAP & TypeMask))
+	if ((PixmapPtr) p == (PixmapPtr) value)
+	    FoundPix = True;
+}
+
 /** Destroy the pixmap pointed to by \a pPixmap. */
 Bool dmxDestroyPixmap(PixmapPtr pPixmap)
 {
@@ -162,7 +179,44 @@ Bool dmxDestroyPixmap(PixmapPtr pPixmap)
 #endif
 
     if (--pPixmap->refcnt)
+    {
+	int i;
+
+	return TRUE;
+
+	FoundPix = False;
+	for (i = currentMaxClients; --i >= 0; )
+	    if (clients[i])
+		FindAllClientResources (clients[i], findPixmap,
+					(pointer) pPixmap);
+
+	if (!FoundPix)
+	{
+	    dmxPixPrivPtr pPixPriv = DMX_GET_PIXMAP_PRIV (pPixmap);
+
+	    if (!pPixPriv->detachedImage)
+	    {
+		ScreenPtr      pScreen   = pPixmap->drawable.pScreen;
+		DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+		pPixPriv->detachedImage = NULL;
+
+		XLIB_PROLOGUE (dmxScreen);
+		pPixPriv->detachedImage = XGetImage(dmxScreen->beDisplay,
+						    pPixPriv->pixmap,
+						    0, 0,
+						    pPixmap->drawable.width,
+						    pPixmap->drawable.height,
+						    -1,
+						    ZPixmap);
+		XLIB_EPILOGUE (dmxScreen);
+		if (!pPixPriv->detachedImage)
+		    ErrorF ("Cannot save pixmap image\n");
+	    }
+	}
+
 	return TRUE;
+    }
 
     /* Destroy pixmap on back-end server */
     if (dmxScreen->beDisplay) {
@@ -193,7 +247,7 @@ RegionPtr dmxBitmapToRegion(PixmapPtr pP
     ScreenPtr      pScreen = pPixmap->drawable.pScreen;
     DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
     dmxPixPrivPtr  pPixPriv = DMX_GET_PIXMAP_PRIV(pPixmap);
-    XImage        *ximage;
+    XImage        *ximage = NULL;
     RegionPtr      pReg, pTmpReg;
     int            x, y;
     unsigned long  previousPixel, currentPixel;
@@ -205,9 +259,13 @@ RegionPtr dmxBitmapToRegion(PixmapPtr pP
 	return pReg;
     }
 
+    XLIB_PROLOGUE (dmxScreen);
     ximage = XGetImage(dmxScreen->beDisplay, pPixPriv->pixmap, 0, 0,
 		       pPixmap->drawable.width, pPixmap->drawable.height,
 		       1, XYPixmap);
+    XLIB_EPILOGUE (dmxScreen);
+    if (!ximage)
+	return NullRegion;
 
     pReg = REGION_CREATE(pScreen, NullBox, 1);
     pTmpReg = REGION_CREATE(pScreen, NullBox, 1);
@@ -219,6 +277,7 @@ RegionPtr dmxBitmapToRegion(PixmapPtr pP
     for (y = 0; y < pPixmap->drawable.height; y++) {
 	Box.y1 = y;
 	Box.y2 = y + 1;
+	Box.x1 = 0;
 	previousPixel = 0L;
 	for (x = 0; x < pPixmap->drawable.width; x++) {
 	    currentPixel = XGetPixel(ximage, x, y);
@@ -251,3 +310,94 @@ RegionPtr dmxBitmapToRegion(PixmapPtr pP
     dmxSync(dmxScreen, FALSE);
     return(pReg);
 }
+
+Bool
+dmxModifyPixmapHeader (PixmapPtr pPixmap,
+		       int	 width,
+		       int	 height,
+		       int	 depth,
+		       int	 bitsPerPixel,
+		       int	 devKind,
+		       pointer	 pPixData)
+{
+    ScreenPtr     pScreen = pPixmap->drawable.pScreen;
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+    int           oldWidth, oldHeight, oldDepth;
+    Bool          status;
+
+    oldWidth  = pPixmap->drawable.width;
+    oldHeight = pPixmap->drawable.height;
+    oldDepth  = pPixmap->drawable.depth;
+
+    DMX_UNWRAP (ModifyPixmapHeader, dmxScreen, pScreen);
+    status = (*pScreen->ModifyPixmapHeader) (pPixmap,
+					     width,
+					     height,
+					     depth,
+					     bitsPerPixel,
+					     devKind,
+					     pPixData);
+    DMX_WRAP (ModifyPixmapHeader, dmxModifyPixmapHeader, dmxScreen, pScreen);
+
+    if (!status)
+	return FALSE;
+
+    if (pPixmap->drawable.width  != oldWidth  ||
+	pPixmap->drawable.height != oldHeight ||
+	pPixmap->drawable.depth  != oldDepth)
+    {
+	dmxBEFreePixmap (pPixmap);
+    }
+
+    if (pPixData && dmxScreen->beDisplay)
+    {
+	dmxPixPrivPtr pPixPriv = DMX_GET_PIXMAP_PRIV (pPixmap);
+	XlibGC        gc = NULL;
+	unsigned long m;
+	XGCValues     v;
+	XImage        ximage;
+
+	ximage.width = pPixmap->drawable.width;
+	ximage.height = pPixmap->drawable.height;
+	ximage.format = ZPixmap;
+	ximage.byte_order = IMAGE_BYTE_ORDER;
+	ximage.bitmap_unit = 32;
+	ximage.bitmap_bit_order = BITMAP_BIT_ORDER;
+	ximage.bitmap_pad = 32;
+	ximage.depth = pPixmap->drawable.depth;
+	ximage.red_mask = 0;
+	ximage.green_mask = 0;
+	ximage.blue_mask = 0;
+	ximage.xoffset = 0;
+	ximage.bits_per_pixel = pPixmap->drawable.bitsPerPixel;
+	ximage.bytes_per_line = pPixmap->devKind;
+	ximage.data = (char *) pPixData;
+
+	XInitImage (&ximage);
+
+	dmxBECreatePixmap (pPixmap);
+
+	m = GCFunction | GCPlaneMask | GCClipMask;
+
+	v.function   = GXcopy;
+	v.plane_mask = AllPlanes;
+	v.clip_mask  = None;
+
+	XLIB_PROLOGUE (dmxScreen);
+	gc = XCreateGC (dmxScreen->beDisplay, pPixPriv->pixmap, m, &v);
+	XLIB_EPILOGUE (dmxScreen);
+
+	if (gc)
+	{
+	    XLIB_PROLOGUE (dmxScreen);
+	    XPutImage (dmxScreen->beDisplay,
+		       pPixPriv->pixmap,
+		       gc, &ximage, 0, 0, 0, 0,
+		       pPixmap->drawable.width, pPixmap->drawable.height);
+	    XFreeGC (dmxScreen->beDisplay, gc);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
+    }
+
+    return TRUE;
+}
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpixmap.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxpixmap.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpixmap.h
@@ -53,6 +53,13 @@ extern PixmapPtr dmxCreatePixmap(ScreenP
 				 unsigned usage_hint);
 extern Bool      dmxDestroyPixmap(PixmapPtr pPixmap);
 extern RegionPtr dmxBitmapToRegion(PixmapPtr pPixmap);
+extern Bool      dmxModifyPixmapHeader (PixmapPtr pPixmap,
+					int	 width,
+					int	 height,
+					int	 depth,
+					int	 bitsPerPixel,
+					int	 devKind,
+					pointer	 pPixData);
 
 extern void      dmxBECreatePixmap(PixmapPtr pPixmap);
 extern Bool      dmxBEFreePixmap(PixmapPtr pPixmap);
